/* BdfServer_API - Copyright (c) 2022 Vincent Calame - Exemole
 * Logiciel libre donné sous triple licence :
 * 1) selon les termes de la CeCILL V2
 * 2) selon les termes de l’EUPL V.1.1
 * 3) selon les termes de la GNU GPLv3
 * Voir le fichier licences.txt
 */


package fr.exemole.bdfserver.api.storage;

import java.util.List;
import java.util.RandomAccess;
import net.mapeadores.util.annotation.Nullable;
import net.mapeadores.util.text.RelativePath;


/**
 *
 * @author Vincent Calame
 */
public interface ResourceStorages extends List<ResourceStorage>, RandomAccess {

    @Nullable
    public ResourceStorage getResourceStorage(String name);

    @Nullable
    public default boolean containsResource(RelativePath relativePath) {
        for (ResourceStorage resourceStorage : this) {
            boolean here = resourceStorage.containsResource(relativePath);
            if (here) {
                return true;
            }
        }
        return false;
    }

}
