/* BdfServer_Html - Copyright (c) 2013-2021 Vincent Calame - Exemole
 * Logiciel libre donné sous triple licence :
 * 1) selon les termes de la CeCILL V2
 * 2) selon les termes de l’EUPL V.1.1
 * 3) selon les termes de la GNU GPLv3
 * Voir le fichier licences.txt
 */


package fr.exemole.bdfserver.html.jslib;


/**
 *
 * @author Vincent Calame
 */
public final class CommonJsLibs {

    public final static JsLib APPELANT = JsLibBuilder.init()
            .addJs("bdf/BDF.Appelant.js")
            .toJsLib();
    public final static JsLib BDFAPI = JsLibBuilder.init()
            .addJs("bdfapi/BdfApi.js")
            .addJs("bdfapi/BdfApi.Config.js")
            .addJs("bdfapi/BdfApi.Ajax.js")
            .addJs("bdfapi/BdfApi.Wrapper.js")
            .toJsLib();
    public final static JsLib CODEMIRRORMODE = JsLibBuilder.init()
            .addJs("bdf/BDF.CodeMirrorMode.js")
            .addThirdLib(JsLib.CODEMIRROR, "xml", "css", "javascript", "properties", "tableexport", "ficheblock", "attributes", "uicomponents", "subsettree")
            .toJsLib();
    public final static JsLib COMMANDTEST = JsLibBuilder.init()
            .addJs("bdf/BDF.CommandTest.js")
            .addThirdLib(JsLib.JQUERY, "form")
            .toJsLib();
    public final static JsLib CURRENCY = JsLibBuilder.init()
            .addJs("currency/Currency.js")
            .toJsLib();
    public final static JsLib DEPLOY = JsLibBuilder.init()
            .addJs("bdf/BDF.Deploy.js")
            .toJsLib();
    public final static JsLib FICHEQL = JsLibBuilder.init()
            .addJs("ficheql/FicheQL.js")
            .addJs("ficheql/FicheQL.Condition.js")
            .addJs("ficheql/FicheQL.Condition.Croisement.js")
            .addJs("ficheql/FicheQL.Condition.Period.js")
            .addJs("ficheql/FicheQL.Fiche.js")
            .addJs("ficheql/FicheQL.Field.js")
            .addJs("ficheql/FicheQL.Motcle.js")
            .toJsLib();
    public final static JsLib FORMSTORAGE = JsLibBuilder.init()
            .addJs("bdf/BDF.FormStorage.js")
            .toJsLib();
    public final static JsLib JQUERY_FORM = JsLibBuilder.init()
            .addThirdLib(JsLib.JQUERY, "form")
            .toJsLib();
    public final static JsLib NAVIGATION = JsLibBuilder.init()
            .addJs("navigation/Navigation.js")
            .toJsLib();
    public final static JsLib OPENDOCUMENT = JsLibBuilder.init()
            .addDependency(UtilsJsLibs.CURRENCY)
            .addDependency(UtilsJsLibs.XMLWRITER)
            .addJs("opendocument/OpenDocument.js")
            .addJs("opendocument/OpenDocument.XmlWriter.js")
            .addJs("opendocument/OpenDocument.Style.js")
            .addJs("opendocument/OpenDocument.TableColumn.js")
            .addJs("opendocument/OpenDocument.CellStyle.js")
            .addJs("opendocument/OpenDocument.OdsConverter.js")
            .toJsLib();
    public final static JsLib PANE = JsLibBuilder.init()
            .addJs("bdf/BDF.Ajax.js")
            .addJs("bdf/BDF.Deploy.js")
            .addJs("bdf/BDF.Pane.js")
            .addThirdLib(JsLib.JQUERY, "form")
            .addTemplateFamily("pane")
            .toJsLib();
    public final static JsLib SELECTFORM = JsLibBuilder.init()
            .addJs("bdf/BDF.Deploy.js")
            .addJs("bdf/BDF.Appelant.js")
            .addJs("bdf/BDF.Selectform.js")
            .addTemplateFamily("selectform")
            .toJsLib();
    public final static JsLib SUBSETCHANGE = JsLibBuilder.init()
            .addJs("bdf/BDF.Subsetchange.js")
            .toJsLib();

    private CommonJsLibs() {
    }

}
