/* global BDF */

BDF.Ajax = {};

BDF.Ajax.loadLangConfiguration = function (langConfigurationCallback) {
    $.ajax({
        url: BDF.URL + "configuration",
        data: {
            json: "langconfiguration"
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
            BDF.processObject(data, "langConfiguration", langConfigurationCallback);
        }
    });
};

BDF.Ajax.loadPathConfiguration = function (pathConfigurationCallback) {
    $.ajax({
        url: BDF.URL + "configuration",
        data: {
            json: "pathconfiguration"
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
            BDF.processObject(data, "pathConfiguration", pathConfigurationCallback);
        }
    });
};

BDF.Ajax.loadTableExportArray = function (tableExportArrayCallback) {
    $.ajax({
        url: BDF.URL + "exportation",
        data: {
            json: "tableexport-array"
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
            BDF.processObject(data, "tableExportArray", tableExportArrayCallback);
        }
    });
};

BDF.Ajax.loadTableExportContent = function (tableExportName, path, tableExportContentCallback) {
    $.ajax({
        url: BDF.URL + "exportation",
        data: {
            json: "tableexport-content",
            tableexport: tableExportName,
            path: path
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
            BDF.processObject(data, "tableExportContent", tableExportContentCallback);
        }
    });
};

BDF.Ajax.loadPatternArrayMap = function (patternArrayMapCallback) {
     $.ajax({
        url: BDF.URL + "main",
        data: {
            json: "availablepatterns"
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
            BDF.processObject(data, "patternArrayMap", patternArrayMapCallback);
        }
    });
};

BDF.Ajax.loadSubsetTreeMap = function (categories, withDetails, subsetTreeMapCallback) {
     $.ajax({
        url: BDF.URL + "configuration",
        data: {
            json: "subsettree-map",
            categories: categories,
            withdetails: withDetails
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
            BDF.processObject(data, "subsetTreeMap", subsetTreeMapCallback);
        }
    });
};

BDF.Ajax.loadScrutariExportArray = function (scrutariExportArrayCallback) {
    $.ajax({
        url: BDF.URL + "exportation",
        data: {
            json: "scrutariexport-array"
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
            BDF.processObject(data, "scrutariExportArray", scrutariExportArrayCallback);
        }
    });
};

BDF.Ajax.loadSqlExportArray = function (sqlExportArrayCallback) {
    $.ajax({
        url: BDF.URL + "exportation",
        data: {
            json: "sqlexport-array"
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
            BDF.processObject(data, "sqlExportArray", sqlExportArrayCallback);
        }
    });
};

BDF.Ajax.loadRoleArray = function (roleArrayCallback) {
    $.ajax({
        url: BDF.URL + "administration",
        data: {
            json: "role-array"
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
            BDF.processObject(data, "roleArray", roleArrayCallback);
        }
    });
};

BDF.Ajax.loadBalayageArray = function (balayageArrayCallback) {
    $.ajax({
        url: BDF.URL + "exportation",
        data: {
            json: "balayage-array"
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
            BDF.processObject(data, "balayageArray", balayageArrayCallback);
        }
    });
};

BDF.Ajax.loadBalayageContent = function (balayageName, path, balayageContentCallback) {
    $.ajax({
        url: BDF.URL + "exportation",
        data: {
            json: "balayage-content",
            balayage: balayageName,
            path: path
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
            BDF.processObject(data, "balayageContent", balayageContentCallback);
        }
    });
};

BDF.Ajax.loadTransformationDescription = function (transformationDescriptionCallback) {
    $.ajax({
        url: BDF.URL + "exportation",
        data: {
            json: "transformation-description"
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
            BDF.processObject(data, "transformationDescription", transformationDescriptionCallback);
        }
    });
};

BDF.Ajax.loadTransformationDescriptionMap = function (keys, transformationDescriptionMapCallback) {
    $.ajax({
        url: BDF.URL + "exportation",
        data: {
            json: "transformation-descriptionmap",
            keys: keys
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
            BDF.processObject(data, "transformationDescriptionMap", transformationDescriptionMapCallback);
        }
    });
};

BDF.Ajax.loadTemplateDescription = function (templateKey, templateDescriptionCallback) {
    $.ajax({
        url: BDF.URL + "exportation",
        data: {
            json: "transformation-templatedescription",
            template: templateKey
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
            BDF.processObject(data, "templateDescription", templateDescriptionCallback);
        }
    });
};

BDF.Ajax.loadTemplateContent = function (templateKey, path, templateContentCallback) {
    $.ajax({
        url: BDF.URL + "exportation",
        data: {
            json: "transformation-templatecontent",
            template: templateKey,
            path: path
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
            BDF.processObject(data, "templateContent", templateContentCallback);
        }
    });
};

BDF.Ajax.loadScrutariExport = function (scrutariExportName, scrutariExportCallback) {
    $.ajax({
        url: BDF.URL + "exportation",
        data: {
            json: "scrutariexport",
            scrutariexport: scrutariExportName
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
            BDF.processObject(data, "scrutariExport", scrutariExportCallback);
        }
    });
};

BDF.Ajax.loadSqlExport = function (sqlExportName, sqlExportCallback) {
    $.ajax({
        url: BDF.URL + "exportation",
        data: {
            json: "sqlexport",
            sqlexport: sqlExportName
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
            BDF.processObject(data, "sqlExport", sqlExportCallback);
        }
    });
};

BDF.Ajax.loadRole = function (roleName, roleCallback) {
    $.ajax({
        url: BDF.URL + "administration",
        data: {
            json: "role",
            role: roleName
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
            BDF.processObject(data, "role", roleCallback);
        }
    });
};

BDF.Ajax.loadResourceTree = function (resourceTreeCallback) {
    $.ajax({
        url: BDF.URL + "administration",
        data: {
            json: "resource-tree"
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
            BDF.processObject(data, "resourceTree", resourceTreeCallback);
        }
    });
};

BDF.Ajax.loadStreamText = function (resourcePath, streamTextCallback) {
    $.ajax({
        url: BDF.URL + "administration",
        data: {
            json: "streamtext",
            path: resourcePath
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
            BDF.processObject(data, "streamText", streamTextCallback);
        }
    });
};

BDF.Ajax.loadMementoUnitInfoArray = function (mementoUnitInfoArrayCallback) {
    $.ajax({
        url: BDF.URL + "misc",
        data: {
            json: "memento-unitinfo-array"
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
            BDF.processObject(data, "mementoUnitInfoArray", mementoUnitInfoArrayCallback);
        }
    });
};

BDF.Ajax.loadMementoUnit = function (path, mementoUnitCallback) {
    $.ajax({
        url: BDF.URL + "misc",
        data: {
            json: "memento-unit",
            path: path
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
            BDF.processObject(data, "mementoUnit", mementoUnitCallback);
        }
    });
};

BDF.Ajax.loadTable = function (tableExportName, subset, tableCallback) {
    $.ajax({
        url: BDF.URL + "main",
        data: {
           json: "table",
           tableexport: tableExportName,
           subset: subset
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
            BDF.processObject(data, "table", tableCallback);
        }
    });
};

BDF.Ajax.loadHistory = function (subset, id, historyCallback) {
    $.ajax({
        url: BDF.URL + "misc",
        data: {
           json: "history",
           subset: subset,
           id: id
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
            BDF.processObject(data, "history", historyCallback);
        }
    });
};

BDF.Ajax.loadRevisionFicheMap = function (corpus, id, revisions, revisionFicheMapCallback) {
    $.ajax({
        url: BDF.URL + "misc",
        data: {
           json: "revision-fiche",
           corpus: corpus,
           id: id,
           revisions: revisions
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
            BDF.processObject(data, "revisionFicheMap", revisionFicheMapCallback);
        }
    });
};

BDF.Ajax.loadUi = function (corpus, uiCallback) {
    $.ajax({
        url: BDF.URL + "corpus",
        data: {
           json: "ui",
           corpus: corpus
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
            BDF.processObject(data, "ui", uiCallback);
        }
    });
};

BDF.Ajax.loadFicheArray = function (ficheQueryXml, ficheArrayCallback) {
    $.ajax({
        url: BDF.URL + "pioche",
        data: {
            json: "fiche",
            xml: ficheQueryXml
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
            BDF.processObject(data, "array", ficheArrayCallback);
        }
    });
};

BDF.Ajax.loadMotcleArray = function (motcleQueryXml, motcleArrayCallback) {
    $.ajax({
        url: BDF.URL + "pioche",
        data: {
            json: "motcle",
            xml: motcleQueryXml
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
            BDF.processObject(data, "array", motcleArrayCallback);
        }
    });
};

BDF.Ajax.loadThesaurus = function (thesaurusName, thesaurusCallback) {    
    $.ajax({
        url: BDF.URL + "thesaurus",
        data: {
            json: "thesaurus",
            thesaurus: thesaurusName
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
             BDF.processObject(data, "thesaurus", thesaurusCallback);
        }
    });
};


/*******************************************************************************
* Initialisation de configuration
*******************************************************************************/

BDF.Ajax.initLangConfiguration = function (callback) {
    BDF.Ajax.loadLangConfiguration(function (langConfiguration) {
        BDF.langConfiguration = langConfiguration;
        callback();
    });
};

BDF.Ajax.initPathConfiguration = function (callback) {
    BDF.Ajax.loadPathConfiguration(function (pathConfiguration) {
        BDF.pathConfiguration = pathConfiguration;
        callback();
    });
};

