/* global BDF,Ficheform,$$ */

Ficheform.AddendaInclude = {};

Ficheform.AddendaInclude.NOCHANGE_STATE = "nochange";
Ficheform.AddendaInclude.UPDATE_STATE = "update";
Ficheform.AddendaInclude.REMOVE_STATE = "remove";
Ficheform.AddendaInclude.CREATE_STATE = "create";
Ficheform.AddendaInclude.DOCUMENT_CHANGETYPE = "document";
Ficheform.AddendaInclude.CREATION_CHANGETYPE = "creation";

Ficheform.AddendaInclude.Document = function () {
};

Ficheform.AddendaInclude.Creation = function () {
};

Ficheform.AddendaInclude.Utils = function () {
};

Ficheform.AddendaInclude.init = function () {
    Ficheform.AddendaInclude.bindFileEvents(BDF.$({ficheformRole: "document-file"}).find("input"));
    BDF.$({ficheformEntry: "addenda-include"}).each(function (index, element) {
        let $entry = $(element);
        let entryKey = $entry.data("ficheformKey");
        let addendaName = BDF.getSubsetName($entry);
        Ficheform.AddendaInclude.checkHidden($entry);
        BDF.$($entry, {ficheformRole: "document"}).each(function (index2, documentDiv) {
            let documentDivId = documentDiv.id;
            var $documentDiv = $(documentDiv);
            $documentDiv.append(BDF.render("ficheform:addenda-document", {
                documentDivId: documentDivId,
                noTab: Ficheform.getOption("noTab")
            }));
            _initDocumentInfo(addendaName, $documentDiv);
            $$(documentDivId, "change").click(function () {
                Ficheform.AddendaInclude.Document.openChange(entryKey, documentDivId);
            });
            $$(documentDivId, "remove").click(function () {
                Ficheform.AddendaInclude.Document.remove(entryKey, documentDivId);
            });
            $$(documentDivId, "restore").click(function () {
                Ficheform.AddendaInclude.Document.restore(entryKey, documentDivId);
            });
        });
        let $addInput = BDF.$($entry, {ficheformRole: "addfield"});
        let addAllowed = ($addInput.length > 0);
        let buttonId = BDF.generateId();
        BDF.$($entry, {ficheformRole: "document-input"}).append(BDF.render("ficheform:addenda-create", {
            buttonId: buttonId,
            addAllowed: addAllowed,
            addendaTitle: BDF.Loc.get("subset:addenda_" + addendaName),
            noTab: Ficheform.getOption("noTab")
        }));
        $$(buttonId, "create").click(function () {
            Ficheform.AddendaInclude.Creation.openNew(entryKey);
        });
        if (addAllowed) {
            $$(buttonId, "add").click(function () {
                Ficheform.AddendaInclude.pioche(entryKey, addendaName, $addInput.attr("id"));
            });
        }
    });

    
    function _initDocumentInfo(addendaName, $documentDiv) {
        var documentInfo = {
            subsetName: addendaName,
            itemId: BDF.getSubsetItemId($documentDiv)
        };
        $documentDiv.data("documentInfo", documentInfo);
    }
    
};

Ficheform.AddendaInclude.checkHidden = function ($entry) {
    let $documentList = BDF.$($entry, {ficheformRole: "document-list"});
    if ($documentList.find("*").length === 0) {
        $documentList.addClass("hidden");
    }
};

Ficheform.AddendaInclude.bindFileEvents = function ($element) {
    $element.on("dragover", function (event) {
        $(this).addClass("global-FileInput_dragover");
        event.preventDefault();
    });
    $element.on("dragleave", function () {
        _removeDragOverClass($(this));
    });
    $element.on("drop", function () {
        _removeDragOverClass($(this));
    });
    $element.on("change", _change);
    
    function _change() {
        let changedFileInput = this;
        let $changedFileInput = $(this);
        _removeDragOverClass($changedFileInput);
        $changedFileInput.addClass("global-FileInput_filled");
        if (changedFileInput.files.length > 1) {
            let array = new Array();
            for(let file of changedFileInput.files) {
                array.push({
                    name: file.name
                });
            }
            let html = BDF.render("ficheform:addenda-filelist", {
                inputId: changedFileInput.id,
                files: array
            });
            let $currentList = $$(changedFileInput.id, "filelist");
            if ($currentList.length > 0) {
                $currentList.replaceWith(html);
            } else {
                $changedFileInput.after(html);
            }
            $changedFileInput.addClass("global-FileInput_filled_many");
        } else {
            $$(changedFileInput.id, "filelist").replaceWith("");
            $changedFileInput.removeClass("global-FileInput_filled_many");
        }
        let $parent = $(this).parent();
        let isFull = true;
        let $fileInputList = $parent.find("input");
        for(let i = 0; i < $fileInputList.length; i++) {
            let fileInput = $fileInputList[i];
            if (fileInput.files.length === 0) {
                isFull = false;
            }
        }
        if (isFull) {
            let texte = '<input type="file" class="ficheform-Full global-FileInput TEMPORARY" name="' + this.name + '" id="' + BDF.generateId() + '" size="70" multiple>';
            $parent.append(texte);
        }
        let $temporary = $parent.find("input.TEMPORARY");
        Ficheform.AddendaInclude.bindFileEvents($temporary);
        $temporary.removeClass("TEMPORARY");
    }
    
    function _removeDragOverClass($input) {
        $input.removeClass("global-FileInput_dragover");
    }
    
};

Ficheform.AddendaInclude.pioche = function (entryKey, subsets, inputId) {
    var $entry = Ficheform.$entry(entryKey);
    var $field = BDF.$($entry, {ficheformRole: "addfield"});
    var limit = $entry.data("ficheformLimit");
    if (!limit) {
        limit = -1;
    }
    var url = "pioche?page=document&subsets=" + subsets + "&appelant=" + inputId + "&limit=" + limit;
    BDF.putAppelantCallback(inputId, _callback);
    Ficheform.openDialog(url,"pioche_" + entryKey, 430, 510);
    
    
    function _callback(selectionArray) {
        var $documentList = BDF.$($entry, {ficheformRole: "document-list"});
        for(let jsonItem of selectionArray) {
            let code = jsonItem.code;
            let existing = BDF.$($documentList, {addCode: code});
            if (existing.length === 0) {
                let documentDivId = BDF.generateId();
                $documentList.append(BDF.render("ficheform:addenda-add", {
                    documentDivId: documentDivId,
                    id: jsonItem.id,
                    code: code,
                    title: jsonItem.title,
                    basename: jsonItem.basename,
                    extensions: jsonItem.extensions,
                    noTab: Ficheform.getOption("noTab")
                }));
                $$(documentDivId, "remove").click(function () {
                    $$(documentDivId).remove();
                    Ficheform.AddendaInclude.Utils.removeValue($field, documentDivId);
                });
               Ficheform.AddendaInclude.Utils.addValue($field, {
                   id: documentDivId,
                   value: jsonItem.id.toString()
               });
            } 
        }
        $documentList.removeClass("hidden");
        Ficheform.signalChange();
    }
};

/** Document ***************************************************************************/

Ficheform.AddendaInclude.Document.openChange = function (entryKey, documentDivId) {
    var $entry = Ficheform.$entry(entryKey);
    var addendaName = BDF.getSubsetName($entry);
    var $documentDiv = $$(documentDivId);
    var appelant = entryKey + "/" + documentDivId;
    BDF.putAppelantCallback(appelant, _callbackChange);
    var documentInfo = $documentDiv.data("documentInfo");
    var url = "addenda?page=document-change&addenda=" + addendaName + "&changetype=" + Ficheform.AddendaInclude.DOCUMENT_CHANGETYPE + "&appelant=" + appelant + "&id=" + documentInfo.itemId;
    if (documentInfo.changeParameter) {
        url = url + "&change=" + encodeURIComponent(documentInfo.changeParameter);
    }
    Ficheform.openDialog(url,"pioche_"+ entryKey, 620, 580);
    
    
    function _callbackChange(appelantResponse) {
        let $field = BDF.$($entry, {ficheformRole: "changefield"});
        let newVal = Ficheform.removeFromValue($field.val(), documentInfo.itemId, ":");
        let appelantResponseString = Ficheform.AddendaInclude.Document.appelantResponseToString(appelantResponse);
        documentInfo.changeParameter = appelantResponseString;
        if (appelantResponseString.length > 0) {
            newVal = newVal + documentInfo.itemId + ":" + appelantResponseString + ";";
        }
        $field.val(newVal);
        Ficheform.AddendaInclude.Utils.updateExtensions(appelantResponse, entryKey, documentDivId);
        Ficheform.signalChange();
    }
};


Ficheform.AddendaInclude.Document.remove = function (entryKey, documentDivId) {
    var ok = confirm(BDF.Loc.get("_ warning.edition.documentremove_existing"));
    if (ok) {
        let $entry = Ficheform.$entry(entryKey);
        let $documentDiv = $$(documentDivId).addClass("ficheform-document-Removed");
        BDF.$($documentDiv, {showState: "active"}).addClass("hidden");
        BDF.$($documentDiv, {showState: "restore"}).removeClass("hidden");
        let documentInfo = $documentDiv.data("documentInfo");
        let $field = BDF.$($entry, {ficheformRole: "removefield"});
        $field.val($field.val() + documentInfo.itemId + ";");
        Ficheform.signalChange();
    }
};

Ficheform.AddendaInclude.Document.restore = function (entryKey, documentDivId) {
    var $entry = Ficheform.$entry(entryKey);
    var $documentDiv = $$(documentDivId).removeClass("ficheform-document-Removed");
    BDF.$($documentDiv, {showState: "active"}).removeClass("hidden");
    BDF.$($documentDiv, {showState: "restore"}).addClass("hidden");
    var $field = BDF.$($entry, {ficheformRole: "removefield"});
    var documentInfo = $documentDiv.data("documentInfo");
    $field.val(Ficheform.removeFromValue($field.val(), documentInfo.itemId));
    Ficheform.signalChange();
};

Ficheform.AddendaInclude.Document.appelantResponseToString = function (appelantResponse) {
    var extensionMap = appelantResponse.extensionMap;
    var text = "";
    for(let extension in extensionMap) {
        let extensionObj = extensionMap[extension];
        let state = extensionObj.state;
        if (state === Ficheform.AddendaInclude.REMOVE_STATE) {
            if (extensionObj.previousState !== Ficheform.AddendaInclude.CREATE_STATE) {
                text += "re=" + extension + ",";
            }
        } else if ((state === Ficheform.AddendaInclude.UPDATE_STATE) || (state === Ficheform.AddendaInclude.CREATE_STATE)) {
            text += "tf=" + extensionObj.tmpFileName + ",";
        }
    }
    if (appelantResponse.basename) {
        text += "bn=" + appelantResponse.basename;
    }
    return text;
};


/** Creation ***************************************************************************/

Ficheform.AddendaInclude.Creation.creationMap = new Object();

Ficheform.AddendaInclude.Creation.remove = function (entryKey, documentDivId) {
    var ok = confirm(BDF.Loc.get("_ warning.edition.documentremove_creation"));
    if (ok) {
        Ficheform.AddendaInclude.Creation.removeCreationInfo(entryKey, documentDivId);
        $$(documentDivId).remove();
        Ficheform.AddendaInclude.checkHidden(Ficheform.$entry(entryKey));
        Ficheform.signalChange();
    }
};

Ficheform.AddendaInclude.Creation.openNew = function (entryKey) {
    var $entry = Ficheform.$entry(entryKey);
    var addendaName = BDF.getSubsetName($entry);
    var appelant = entryKey;
    BDF.putAppelantCallback(appelant, _callback);
    var url = "addenda?page=document-upload-new&addenda=" + addendaName  + "&appelant=" + appelant;
    Ficheform.openDialog(url, "pioche_" + entryKey, 620, 580);
    
    
    function _callback(appelantResponse) {
        let extensionMap = appelantResponse.extensionMap;
        let extensionText = "";
        let next = false;
        for(let extension in extensionMap) {
            let extensionObj = extensionMap[extension];
            let state = extensionObj.state;
            if ((state === Ficheform.AddendaInclude.UPDATE_STATE) || (state === Ficheform.AddendaInclude.CREATE_STATE)) {
                if (next) {
                    extensionText += " / ";
                } else {
                    next = true;
                }
                extensionText += "." + extension;
            }
        }
        let documentDivId = BDF.generateId();
        BDF.$($entry, {ficheformRole: "document-list"}).append(BDF.render("ficheform:addenda-new", {
            documentDivId: documentDivId,
            basename: appelantResponse.basename,
            extensionText: extensionText,
            noTab: Ficheform.getOption("noTab")
        })).removeClass("hidden");
        $$(documentDivId, "change").click(function () {
            Ficheform.AddendaInclude.Creation.openChange(entryKey, documentDivId);
        });
        $$(documentDivId, "remove").click(function () {
            Ficheform.AddendaInclude.Creation.remove(entryKey, documentDivId);
        });
        Ficheform.AddendaInclude.Creation.addCreationInfo(entryKey, documentDivId, Ficheform.AddendaInclude.Utils.appelantResponseToString(appelantResponse), appelantResponse.originalName);
        Ficheform.signalChange();
    }
};

Ficheform.AddendaInclude.Creation.openChange = function (entryKey, documentDivId) {
    var $entry = Ficheform.$entry(entryKey);
    var addendaName = BDF.getSubsetName($entry);
    var appelant = entryKey + "/" + documentDivId;
    BDF.putAppelantCallback(appelant, _callback);
    var creationInfo = Ficheform.AddendaInclude.Creation.getCreationInfo(entryKey, documentDivId);
    var url = "addenda?page=document-change&addenda=" + addendaName + "&changetype=" + Ficheform.AddendaInclude.CREATION_CHANGETYPE + "&appelant=" + appelant
        + "&originalname=" + encodeURIComponent(creationInfo.originalName)
        + "&change=" + encodeURIComponent(creationInfo.changeParameter);
    Ficheform.openDialog(url,"pioche_"+ entryKey, 620, 580);
    
    
    function _callback(appelantResponse) {
        creationInfo.changeParameter = Ficheform.AddendaInclude.Document.appelantResponseToString(appelantResponse);
        Ficheform.AddendaInclude.Utils.updateExtensions(appelantResponse, entryKey, documentDivId);
        Ficheform.AddendaInclude.Utils.updateInput(BDF.$($entry, {ficheformRole: "createfield"}));
        Ficheform.signalChange();
    }
};

Ficheform.AddendaInclude.Creation.appelantResponseToString = function (appelantResponse) {
    var extensionMap = appelantResponse.extensionMap;
    var text = appelantResponse.basename + ":";
    for(let extension in extensionMap) {
        let extensionObj = extensionMap[extension];
        let state = extensionObj.state;
        if ((state === Ficheform.AddendaInclude.UPDATE_STATE) || (state === Ficheform.AddendaInclude.CREATE_STATE)) {
            text += extensionObj.tmpFileName + ",";
        }
    }
    return text;
};

Ficheform.AddendaInclude.Creation.removeCreationInfo = function (entryKey, documentDivId) {
    var $entry = Ficheform.$entry(entryKey);
    var $field = BDF.$($entry, {ficheformRole: "createfield"});
    Ficheform.AddendaInclude.Utils.removeValue($field, documentDivId); 
};

Ficheform.AddendaInclude.Creation.getCreationInfo = function (entryKey, documentDivId) {
    var $entry = Ficheform.$entry(entryKey);
    var $field = BDF.$($entry, {ficheformRole: "createfield"});
    return Ficheform.AddendaInclude.Utils.getValue($field, documentDivId);  
};

Ficheform.AddendaInclude.Creation.addCreationInfo = function (entryKey, documentDivId, changeParameter, originalName) {
    var $entry = Ficheform.$entry(entryKey);
    var $field = BDF.$($entry, {ficheformRole: "createfield"});
    var obj = {id: documentDivId, value: changeParameter, changeParameter: changeParameter, originalName: originalName};
    Ficheform.AddendaInclude.Utils.addValue($field, obj);
    return obj;
};


/** Utils ***************************************************************************/

Ficheform.AddendaInclude.Utils.appelantResponseToString = function (appelantResponse) {
    var extensionMap = appelantResponse.extensionMap;
    var text = "";
    for(let extension in extensionMap) {
        let extensionObj = extensionMap[extension];
        let state = extensionObj.state;
        if (state === Ficheform.AddendaInclude.REMOVE_STATE) {
            if (extensionObj.previousState !== Ficheform.AddendaInclude.CREATE_STATE) {
                text += "re=" + extension + ",";
            }
        } else if ((state === Ficheform.AddendaInclude.UPDATE_STATE) || (state === Ficheform.AddendaInclude.CREATE_STATE)) {
            text += "tf=" + extensionObj.tmpFileName + ",";
        }
    }
    if (appelantResponse.basename) {
        text += "bn=" + appelantResponse.basename;
    }
    return text;
};

Ficheform.AddendaInclude.Utils.updateExtensions = function (appelantResponse, entryKey, documentDivId) {
    var $entry = Ficheform.$entry(entryKey);
    var addenda = BDF.getSubsetName($entry);
    var $document = $$(documentDivId);
    if (appelantResponse.basename) {
        var $basename = BDF.$($document, {ficheformRole: "document-basename"});
        $basename.html(appelantResponse.basename);
        if (appelantResponse.changeType === Ficheform.AddendaInclude.DOCUMENT_CHANGETYPE) {
            $basename.addClass("ficheform-document-NameChanged");
        }
    }
    var extensionMap = appelantResponse.extensionMap;
    var extensionArray = new Array();
    for(let extension in extensionMap) {
        let extensionObj = extensionMap[extension];
        let cssClass, href;
        let state = extensionObj.state;
        if (state === Ficheform.AddendaInclude.UPDATE_STATE) {
            href = BDF.toTmpPath(extensionObj.tmpFileName);
            cssClass = "ficheform-document-VersionChanged";
        } else if (state === Ficheform.AddendaInclude.CREATE_STATE) {
            href =  BDF.toTmpPath(extensionObj.tmpFileName);
            cssClass = "ficheform-document-VersionAdded";
        } else if (state === Ficheform.AddendaInclude.REMOVE_STATE) {
            if (extensionObj.previousState === Ficheform.AddendaInclude.CREATE_STATE) {
                continue;
            }
            if (extensionObj.tmpFileName) {
                href =  BDF.toTmpPath(extensionObj.tmpFileName);
            } else {
                href = "documents/" + addenda + "/" + extensionObj.currentFileName;
            }
            cssClass = "ficheform-document-VersionRemoved";
        } else {
            href = "documents/" + addenda + "/"  + extensionObj.currentFileName;
            cssClass = false;
        }
        extensionArray.push({
            href: href,
            cssClass: cssClass,
            extension: extension
        });
    }
    BDF.$($document, {ficheformRole: "document-extensions"}).html(BDF.render("ficheform:addenda-extensions", {
        extensionArray: extensionArray,
        noTab: Ficheform.getOption("noTab")
    }));
    Ficheform.signalChange();
};

Ficheform.AddendaInclude.Utils.removeValue = function ($field, objId) {
    var valueArray = $field.data("valueArray");
    Ficheform.AddendaInclude.Utils.updateInput($field);
    if (valueArray) {
        let length = valueArray.length;
        for(let i = 0; i < length; i++) {
            if (valueArray[i].id === objId) {
                if (i === (length - 1)) {
                    valueArray.pop();
                } else {
                    valueArray.splice(i,1);
                    break;
                }
            }
        }
        Ficheform.AddendaInclude.Utils.updateInput($field);
    }    
};

Ficheform.AddendaInclude.Utils.addValue = function ($field, obj) {
    var valueArray = $field.data("valueArray");
    if (!valueArray) {
        valueArray = new Array();
        valueArray[0] = obj;
        $field.data("valueArray", valueArray);
    } else {
        valueArray.push(obj);
    }
    Ficheform.AddendaInclude.Utils.updateInput($field);
};

Ficheform.AddendaInclude.Utils.getValue = function ($field, objId) {
    Ficheform.AddendaInclude.Utils.updateInput($field);
    var valueArray = $field.data("valueArray");
    if (valueArray) {
        for(let obj of valueArray) {
            if (obj.id === objId) {
                return obj;
            }
        }
    }
    return null;
};

Ficheform.AddendaInclude.Utils.updateInput = function ($field) {
    var valueArray = $field.data("valueArray");
    if (!valueArray) {
        $field.val("");
        return;
    }
    var text = "";
    for(let obj of valueArray) {
        text += obj.value;
        text += ";";
    }
    $field.val(text);
    Ficheform.signalChange();
};