/* global BDF,Ficheform */

Ficheform.ThesaurusInclude = {};

Ficheform.ThesaurusInclude.init = function () {
    BDF.$({ficheformEntry: "thesaurus-include"}).each(function (index, element) {
        let $entry = $(element);
        let entryKey = $entry.data("ficheformKey");
        let subsetName = BDF.getSubsetName($entry);
        let inputId = BDF.$($entry, {ficheformRole: "textinput"})[0].id;
        let buttonId = BDF.generateId();
        let isExternalSource, action, locKey;
        if ($entry.data("ficheformExternalsource")) {
            isExternalSource = true;
            action = "action-ficheform-ExternalSource";
            locKey = "_ link.pioche.externalsource";
        } else {
            isExternalSource = false;
            action = "action-ficheform-Motcle";
            locKey = "_ link.pioche.motcle_one";
        }
        BDF.$children($entry, {ficheformRole: "motcle-input"}).append(BDF.render("ficheform:pioche", {
            buttonId: buttonId,
            action: action,
            locKey: locKey,
            locValue:  BDF.Loc.get("subset:thesaurus_" + subsetName),
            noTab: Ficheform.getOption("noTab")
        }));
        $$(buttonId).click(function () {
            _pioche(entryKey, subsetName, inputId, isExternalSource);
        });
        if (BDF.$($entry, {ficheformRole: "poids"}).length > 0) {
            Ficheform.initPoidsInput($entry);
        }
    });

    
    function _pioche(entryKey, subsets, inputId, isExternalSource) {
        let page;
        if (isExternalSource) {
            page = "externalsource";
        } else {
            page = "motcle";
        }
        let $entry = Ficheform.$entry(entryKey);
        let limit = $entry.data("ficheformLimit");
        if (!limit) {
            limit = -1;
        }
        let url = "pioche?page=" + page + "&subsets=" + subsets + "&appelant=" + inputId + "&limit=" + limit;
        url = url + "&croisement=corpus_" + BDF.$({ficheformRole: "form"}).data("ficheformCorpus");
        let wanted = $entry.data("ficheformWanted");
        if (wanted) {
            url = url + "&wanted=" +  wanted;
        }
        Ficheform.openDialog(url,"pioche_"+ entryKey,430,510);
    };
    
};

