/* UtilLib - Copyright (c) 2009-2017 Vincent Calame - Exemole
 * Logiciel libre donné sous triple licence :
 * 1) selon les termes de la CeCILL V2
 * 2) selon les termes de l’EUPL V.1.1
 * 3) selon les termes de la GNU GPLv3
 * Voir le fichier licences.txt
 */


package net.mapeadores.util.attr;

import java.util.List;
import java.util.RandomAccess;


/**
 * Liste de chaines répondant aux conditions suivantes : - au moins une valeur -
 * les valeurs ne sont jamais nulles, de longueur nulles et ne commencent ni
 * finissent par des espaces blancs (value.trim() = value)
 *
 * @author Vincent Calame
 */
public interface Attribute extends List<String>, RandomAccess {

    /**
     * N'est jamais nul
     */
    public AttributeKey getAttributeKey();

    /**
     * Indentique à get(0). Rappel qu'il doit toujours y avoir au moins une
     * valeur.
     *
     */
    public String getFirstValue();

}
